package myPlugins;

import tersus.model.BuiltinModels;
import tersus.model.Model;
import tersus.model.Role;
import tersus.runtime.EngineException;
import tersus.runtime.FlowInstance;
import tersus.runtime.Plugin;
import tersus.runtime.RuntimeContext;
import tersus.runtime.SlotHandler;

public class Factorial extends Plugin {
	
	
	private static final Role N = Role.get("<N>");
	private static final Role FACTORIAL = Role.get("<Factorial>");
	private SlotHandler nTrigger, factorialExit;
	public void initializeFromModel(Model model) {
		super.initializeFromModel(model);
		nTrigger = getRequiredMandatoryTrigger(N, Boolean.FALSE, BuiltinModels.NUMBER_ID);
		factorialExit = getRequiredExit(FACTORIAL, Boolean.FALSE, BuiltinModels.NUMBER_ID);
	}

	public void start(RuntimeContext context, FlowInstance flow) {
		int n = getTriggerValue(nTrigger, context, flow, 0);
		if (n < 0)
			fireError(context, flow, new EngineException("Cannot compute factorial of a negative number",null,null));
		long f = factorial(n);
		setExitValue(factorialExit, context, flow, f);
	}

	private long factorial(int n) {
		int x;
		long f = 1;
        for ( x = 1 ; x <= n ; x++ )
            f = f*x;
        return f;
	}

}
