package myPlugins;

import mypackage.MyClass;
import tersus.model.BuiltinModels;
import tersus.model.Model;
import tersus.model.Role;
import tersus.runtime.EngineException;
import tersus.runtime.FlowInstance;
import tersus.runtime.Plugin;
import tersus.runtime.RuntimeContext;
import tersus.runtime.SlotHandler;

public class Fibonacci extends Plugin {
	
	
	private static final Role N = Role.get("<N>");
	private static final Role FIBONACCI = Role.get("<Fibonacci>");
	private SlotHandler nTrigger, fibonacciExit;
	public void initializeFromModel(Model model) {
		super.initializeFromModel(model);
		nTrigger = getRequiredMandatoryTrigger(N, Boolean.FALSE, BuiltinModels.NUMBER_ID);
		fibonacciExit = getRequiredExit(FIBONACCI, Boolean.FALSE, BuiltinModels.NUMBER_ID);
	}

	public void start(RuntimeContext context, FlowInstance flow) {
		int n = getTriggerValue(nTrigger, context, flow, 0);
		if (n < 0)
			fireError(context, flow, new EngineException("Cannot compute a fibonacci number for a negative index",null,null));
		long f = MyClass.fibonacci(n);
		setExitValue(fibonacciExit, context, flow, f);
	}
}
