package myPlugins;

import java.util.List;

import tersus.model.Model;
import tersus.model.Role;
import tersus.runtime.ElementHandler;
import tersus.runtime.FlowInstance;
import tersus.runtime.InstanceHandler;
import tersus.runtime.Plugin;
import tersus.runtime.RuntimeContext;
import tersus.runtime.SlotHandler;

public class Transform extends Plugin {

	public final static Role INPUT = Role.get("<Input>");
	public final static Role IN1 = Role.get("IN1");
	public final static Role IN2 = Role.get("IN2");
	public final static Role OUTPUT = Role.get("<Output>");
	public final static Role OUT1 = Role.get("OUT1");
	public final static Role OUT2 = Role.get("OUT2");
	
	
	SlotHandler inTrigger, outExit;
	InstanceHandler inType, outType;
	ElementHandler in1, in2, out1, out2;
	public void initializeFromModel(Model model) {
		super.initializeFromModel(model);
		inTrigger = getRequiredMandatoryTrigger(INPUT, Boolean.TRUE, null);
		outExit = getRequiredExit(OUTPUT, Boolean.TRUE, null);
		inType = inTrigger.getChildInstanceHandler();
		outType = outExit.getChildInstanceHandler();
		
		in1 = inType.getElementHandler(IN1);
		in2 = inType.getElementHandler(IN2);
		out1 = outType.getElementHandler(OUT1);
		out2 = outType.getElementHandler(OUT2);
	}

	public void start(RuntimeContext context, FlowInstance flow) {
		
		@SuppressWarnings("unchecked")
		List<Object> inputList = (List<Object>)inTrigger.get(context, flow);
		
		for (Object in:inputList)
		{
			Object out = outType.newInstance(context);
			Object v1 = in1.get(context, in);
			Object v2 = in2.get(context, in);
			
			out1.set(context,  out, v2);
			out2.set(context, out , v1);
			
			accumulateExitValue(outExit, context, flow, out);
		}
	}
	

}
